package infrastructure

import (
	"errors"

	"code.osinet.fr/fgm/kurz/domain"
)

type urlmap map[domain.URL]domain.URL

var targets = make(urlmap)
var shorts = make(urlmap)

type MemoryShortURLRepository struct {
}

func (r MemoryShortURLRepository) GetTarget(su domain.ShortURL) (domain.TargetURL, error) {
	var tu domain.TargetURL
	var err error

	if t, ok := targets[su.URL]; ok {
		tu = domain.TargetURL{URL: t}
	} else {
		err = errors.New("not found")
	}
	return tu, err
}

func (r MemoryShortURLRepository) GetByTarget(tu domain.TargetURL) (domain.ShortURL, error) {
	var su domain.ShortURL
	var err error

	if s, ok := shorts[tu.URL]; ok {
		su = domain.ShortURL{URL: s}
	} else {
		err = errors.New("not found")
	}
	return su, err
}

func (r MemoryShortURLRepository) add(s domain.ShortURL, t domain.TargetURL) {
	targets[s.URL] = t.URL
	shorts[t.URL] = s.URL
}
